#include <SoftwareSerial.h>

#define BLYNK_PRINT Serial
#define BLYNK_TEMPLATE_ID "TMPL4rEkaOOQ0"
#define BLYNK_TEMPLATE_NAME "Nodemcu GPS"
#define BLYNK_AUTH_TOKEN "w9H5cY2xAx3lkp-fMX5S3rE39f_SVbzN"

#define WIFI_SSID "Název sítě"
#define WIFI_PASSWORD "Heslo"

#include <NMEAGPS.h>
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>

// GPS module 1
#define RX_PIN_1 15
#define TX_PIN_1 13

// GPS module 2
#define RX_PIN_2 12
#define TX_PIN_2 14

// GPS module 3
#define RX_PIN_3 4
#define TX_PIN_3 5

#define GPS_BAUD 9600

SoftwareSerial gps_module_1(RX_PIN_1, TX_PIN_1);
SoftwareSerial gps_module_2(RX_PIN_2, TX_PIN_2);
SoftwareSerial gps_module_3(RX_PIN_3, TX_PIN_3);

NMEAGPS gps; 
gps_fix fix;

void collectData(SoftwareSerial &gps_module)
{
  gps_fix fix = gps.read();

  unsigned int move_index = 1; 
  float gps_speed;
  uint8_t no_of_satellites;
  String satellite_orientation;

  WidgetMap myMap(V0);

  if (fix.valid.location) {
    //Storing the Latitude. and Longitude
    float latitude = fix.latitude();
    float longitude = fix.longitude(); 
    
    //Send to Serial Monitor for Debugging
    Serial.print("LAT:  ");
    Serial.println(latitude, 6);  // float to x decimal places
    Serial.print("LONG: ");
    Serial.println(longitude, 6);
    
    Blynk.virtualWrite(V1, String(latitude, 6));   
    Blynk.virtualWrite(V2, String(longitude, 6));  
    myMap.location(move_index, latitude, longitude, "GPS_Location");
    
    //get speed
    gps_speed = fix.speed_kph();
    Blynk.virtualWrite(V3, gps_speed);
      
    //get number of satellites
    no_of_satellites = fix.satellites;
    Blynk.virtualWrite(V4, no_of_satellites);

    // get the satellite orientation/direction
    Blynk.virtualWrite(V5, satellite_orientation);
  }
}
  
void setup()
{
  Serial.begin(74880);
  Serial.println("Starting GPS Test...");
  
  gps_module_1.begin(GPS_BAUD);
  gps_module_2.begin(GPS_BAUD);
  gps_module_3.begin(GPS_BAUD);

  Blynk.begin(BLYNK_AUTH_TOKEN, WIFI_SSID, WIFI_PASSWORD); 
}

void loop()
{
  if (!Blynk.connected()) {
    Blynk.connect();
  }

  while (gps_module_1.available() > 0) {
    collectData(gps_module_1);
  }

  while (gps_module_2.available() > 0) {
    collectData(gps_module_2);
  }

   while (gps_module_3.available() > 0) {
    collectData(gps_module_3);
  }
}